com.gisgraphy.domain.repository

## Interface IOpenStreetMapDao

- All Superinterfaces:
    IDao<OpenStreetMap,Long>
  All Known Implementing Classes:
    OpenStreetMapDao

      public interface IOpenStreetMapDao
      extends IDao<OpenStreetMap,Long>

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `long` | `countEstimate()`
    `void` | `createFulltextIndexes()` Create the fulltext index for openstreetMap to improve performances
    `void` | `createSpatialIndexes()` Create the database GIST for openstreetMap to improve performances
    `OpenStreetMap` | `getByGid(Long gid)`
    `OpenStreetMap` | `getByOpenStreetMapId(Long openstreetmapId)`
    `long` | `getMaxGid()`
    `long` | `getMaxOpenstreetMapId()`
    `List<com.gisgraphy.domain.valueobject.StreetDistance>` | `getNearestAndDistanceFrom(com.vividsolutions.jts.geom.Point point, double distance, int firstResult, int maxResults, com.gisgraphy.street.StreetType streetType, Boolean oneWay, String name, com.gisgraphy.street.StreetSearchMode streetSearchMode, boolean includeDistanceField)` base method for all findNearest
    `OpenStreetMap` | `getNearestByosmIds(com.vividsolutions.jts.geom.Point point, List<Long> ids)`
    `OpenStreetMap` | `getNearestFrom(com.vividsolutions.jts.geom.Point point)` find the nearest street based on the shape, not the middle point
    `OpenStreetMap` | `getNearestFrom(com.vividsolutions.jts.geom.Point point, boolean onlyroad, boolean filterEmptyName)`
    `OpenStreetMap` | `getNearestRoadFrom(com.vividsolutions.jts.geom.Point point)` find the nearest road based on the shape, not the middle point and exclude footway
    `String` | `getShapeAsWKTByGId(Long gid)`
    `Integer` | `updateTS_vectorColumnForStreetNameSearch()` Update the ts_vector column for the street name search (partial search and fulltext search)
    `Integer` | `updateTS_vectorColumnForStreetNameSearchPaginate(long from, long to)` Update the ts_vector column for the street name search from the gid that are >= from and < to

    - ### Methods inherited from interface com.gisgraphy.domain.repository.IDao

      `count, deleteAll, deleteAll, exists, flushAndClear, get, getAll, getAllPaginate, getPersistenceClass, remove, save, setFlushMode`

- - ### Method Detail

    - #### getNearestAndDistanceFrom

          List<com.gisgraphy.domain.valueobject.StreetDistance> getNearestAndDistanceFrom(com.vividsolutions.jts.geom.Point point,
                                                                                        double distance,
                                                                                        int firstResult,
                                                                                        int maxResults,
                                                                                        com.gisgraphy.street.StreetType streetType,
                                                                                        Boolean oneWay,
                                                                                        String name,
                                                                                        com.gisgraphy.street.StreetSearchMode streetSearchMode,
                                                                                        boolean includeDistanceField)

      base method for all findNearest
      Parameters:
        `point` - The point from which we want to find GIS Object
        `distance` - The radius in meters
        `firstResult` - the firstResult index (for pagination), numbered from 1, if < 1 : it will not be taken into account
        `maxResults` - The Maximum number of results to retrieve (for pagination), if <= 0 : it will not be taken into acount
        `streetType` - The type of street
        `oneWay` - whether the street should be oneway or not
        `name` - the name the street name must contains
        `streetSearchMode` - if we search in fulltext or contain mode
        `includeDistanceField` - if we have to calculate the distance or not
      Returns:
        A List of StreetDistance with the nearest elements or an empty list (never return null), ordered by distance.
      See Also:
        `StreetDistance`

    - #### getByGid

          OpenStreetMap getByGid(Long gid)

      Parameters:
        `gid` - the gid of the openstreetmap entity we want to retrieve
      Returns:
        the OpenstreetMap entity or null if not found

    - #### updateTS_vectorColumnForStreetNameSearch

          Integer updateTS_vectorColumnForStreetNameSearch()

      Update the ts_vector column for the street name search (partial search and fulltext search)
      Returns:
        the number of line updated
      See Also:
        `StreetSearchMode`

    - #### updateTS_vectorColumnForStreetNameSearchPaginate

          Integer updateTS_vectorColumnForStreetNameSearchPaginate(long from,
                                                                 long to)

      Update the ts_vector column for the street name search from the gid that are >= from and < to
      Parameters:
        `from` - the start pagination index of gid
        `to` - the end pagination index (partial search and fulltext search)
      Returns:
        the number of line updated
      See Also:
        `StreetSearchMode`

    - #### createSpatialIndexes

          void createSpatialIndexes()

      Create the database GIST for openstreetMap to improve performances

    - #### createFulltextIndexes

          void createFulltextIndexes()

      Create the fulltext index for openstreetMap to improve performances

    - #### countEstimate

          long countEstimate()

      Returns:
        the number of streets based on the highest gid

    - #### getByOpenStreetMapId

          OpenStreetMap getByOpenStreetMapId(Long openstreetmapId)

      Parameters:
        `openstreetmapId` - the openstreetmap id (not the id, not the gid)
      Returns:
        the openstreetmap

    - #### getNearestByosmIds

          OpenStreetMap getNearestByosmIds(com.vividsolutions.jts.geom.Point point,
                                         List<Long> ids)

      Parameters:
        `point` - the point to search around
        `ids` - the openstreetmap ids of streets we want to restrict search
      Returns:
        the nearest street of all the streets with the ids specified, for the given point

    - #### getMaxOpenstreetMapId

          long getMaxOpenstreetMapId()

      Returns:
        the highest openstreetMapId

    - #### getMaxGid

          long getMaxGid()

      Returns:
        the highest Gid

    - #### getNearestFrom

          OpenStreetMap getNearestFrom(com.vividsolutions.jts.geom.Point point)

      find the nearest street based on the shape, not the middle point
      Parameters:
        `point` - The point from which we want to find street

    - #### getNearestRoadFrom

          OpenStreetMap getNearestRoadFrom(com.vividsolutions.jts.geom.Point point)

      find the nearest road based on the shape, not the middle point and exclude footway
      Parameters:
        `point` - The point from which we want to find street

    - #### getNearestFrom

          OpenStreetMap getNearestFrom(com.vividsolutions.jts.geom.Point point,
                                     boolean onlyroad,
                                     boolean filterEmptyName)

      Parameters:
        `point` -
        `onlyroad` -
        `filterEmptyName` - filter street with name=null
      Returns:
        the nearest street based on the shape, not the middle point

    - #### getShapeAsWKTByGId

          String getShapeAsWKTByGId(Long gid)

      Parameters:
        `gid` - the gid of the feature
      Returns:
        the shape as wkt

Copyright © 2015. All rights reserved.